/**
  main.c
*/

#include <stdlib.h>
#include "stm32f4xx.h"
#include "stm32f4xx_hal.h"

#include "stm32f4xx_hal_uart.h"
#include "stm32f429i_discovery.h"
#include "stm32f429i_discovery_lcd.h"

#include "system_clocks.h"
#include "simpleLCD.h"
#include "gyro_spi.h"
#include "serial.h"

/* Private typedef -----------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

/* Private macro -----------------------
 * --------------------------------------*/
/* Private variables ---------------------------------------------------------*/


/* UART handler declaration */
UART_HandleTypeDef UartHandle;

static char str[30]={0};

/* Private function prototypes -----------------------------------------------*/
static void EXTILine0_Config(void);

/* Private functions ---------------------------------------------------------*/


int main(void){

  HAL_Init();

  /* Configure LED3 and LED4 */
  BSP_LED_Init(LED3);
  BSP_LED_Init(LED4);
  BSP_LED_Off(LED3);
  BSP_LED_Off(LED4);
  /* Configure the system clock to 180 MHz */
  SystemClock_Config();

  /* Configure EXTI Line0 (connected to PA0 pin) in interrupt mode */
  EXTILine0_Config();

  LCD_Init();
  LCD_SetFont(FONT16);
  Serial_Init();
  Serial_Send((uint8_t*)"UART Start OK \n ", 15);
  // Gyro SPI
  if( GYRO_SPI_Init() != GSPI_OK){
	  Error_Handler();
  }
  LCD_PrintXY(6,1,"Witam !");
  LCD_PrintXY(3,2,"Gyroskop SPI");
//  uint8_t id = GYRO_SPI_Get_ID();
//  snprintf(str,30,"Gyro ID = %04X  ",id);
  LCD_PrintXY(2,3,str);

//  uint8_t temp = GYRO_SPI_Get_Temp();
//  snprintf(str,30,"Temperatura  = %3u  ",(uint16_t)temp);
  LCD_PrintXY(2,5,str);
  /* Infinite loop */
  while(1){
    BSP_LED_Toggle(LED3); //czyli PG13

    float tempx = GYRO_SPI_Get_X();
    snprintf(str,30,"X = %8.1f       ", tempx);
    LCD_PrintXY(2,7,str);
    HAL_Delay(200);

  }
}

/**
  * @brief  Configures EXTI Line0 (connected to PA0 pin) in interrupt mode
  * @param  None
  * @retval None
  */
static void EXTILine0_Config(void)
{
  GPIO_InitTypeDef   GPIO_InitStructure;

  /* Enable GPIOA clock */
  __HAL_RCC_GPIOA_CLK_ENABLE();

  /* Configure PA0 pin as input floating */
  GPIO_InitStructure.Mode = GPIO_MODE_IT_FALLING;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = GPIO_PIN_0;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStructure);

  /* Enable and set EXTI Line0 Interrupt to the lowest priority */
  HAL_NVIC_SetPriority(EXTI0_IRQn, 2, 0);
  HAL_NVIC_EnableIRQ(EXTI0_IRQn);
}

/**
  * @brief EXTI line detection callbacks
  * @param GPIO_Pin: Specifies the pins connected EXTI line
  * @retval None
  */
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
  if(GPIO_Pin == KEY_BUTTON_PIN)
  {
    //*** TU wpisz reakcję na przycisk
    // np.
    /* Toggle LED3 */
    //BSP_LED_Toggle(LED3);
	//startTime = HAL_GetTick();
  }
}

/*
void HAL_SYSTICK_Callback(void)
{
  // tu wpisz obsługę SysTick
  // czyli co ma byc wykonywane co 1[ms]

}

*/

